package com.jenny.magic.items;

import net.minecraft.ChatFormatting;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.level.Level;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Random;

public class QualityItem extends BaseItem {
    public QualityItem(Properties pProperties) {
        super(pProperties);
    }

    @Override
    public ItemStack getDefaultInstance() {
        return setQuality(new ItemStack(this));
    }

    protected ItemStack setQuality(@NotNull ItemStack itemStack) {
        float quality = (float) new Random(System.nanoTime()).nextInt(0, 21) / 10 + 1;
        CompoundTag tag;
        if (itemStack.getTag() != null) {
            tag = itemStack.getTag();
        } else {
            tag = new CompoundTag();
        }
        tag.putFloat("magic_quality", quality);
        itemStack.setTag(tag);
        return itemStack;
    }

    protected float getQuality(@NotNull ItemStack itemStack) {
        return itemStack.getTag() != null ? itemStack.getTag().getFloat("magic_quality") : 1;
    }

    @Override
    public void appendHoverText(@NotNull ItemStack pStack, @Nullable Level pLevel, @NotNull List<Component> pTooltipComponents, @NotNull TooltipFlag pIsAdvanced) {
        MutableComponent toolTip = Component.literal(Float.toString(getQuality(pStack)));
        pTooltipComponents.add(toolTip.withStyle(ChatFormatting.DARK_RED));
        super.appendHoverText(pStack, pLevel, pTooltipComponents, pIsAdvanced);
    }
}
