package com.jenny.magic.mixins;

import net.minecraft.core.NonNullList;
import net.minecraft.core.RegistryAccess;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.ShapelessRecipe;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.Shadow;

@Mixin(ShapelessRecipe.class)
public class ShapelessRecipeMixin {
    @Final
    @Shadow
    ItemStack result;

    @Final
    @Shadow
    NonNullList<Ingredient> ingredients;

    /**
     * @author xJenny69
     * @reason allow "magic_quality" tag to be passed on
     */
    @Overwrite
    public ItemStack assemble(CraftingContainer pContainer, RegistryAccess pRegistryAccess) {
        for (Ingredient ingredient : ingredients) {
            for (ItemStack itemStack : ingredient.getItems()) {
                if (itemStack.getTag() != null && itemStack.getTag().contains("magic_quality")) {
                    CompoundTag tag = result.getTag();
                    tag.putFloat("magic_quality", itemStack.getTag().getFloat("magic_quality"));
                    result.setTag(tag);
                    return result.copy();
                }
            }
        }
        return result.copy();
    }

    /**
     * @author
     * @reason
     */
    @Overwrite
    public ItemStack getResultItem(RegistryAccess pRegistryAccess) {
        for (Ingredient ingredient : ingredients) {
            for (ItemStack itemStack : ingredient.getItems()) {
                if (itemStack.getTag() != null && itemStack.getTag().contains("magic_quality")) {
                    CompoundTag tag = result.getTag();
                    tag.putFloat("magic_quality", itemStack.getTag().getFloat("magic_quality"));
                    result.setTag(tag);
                    return result.copy();
                }
            }
        }
        return result.copy();
    }

}
